<!-- 计量人员列表弹窗 -->
<script lang="ts" setup name="selectPerson">
import { ElMessage } from 'element-plus'
import { getStaffDetail, getStaffList } from '@/api/measure/person'
import { getDeptTreeList } from '@/api/system/dept'
// import type { TreeStructure } from '@/views/system/user/user-interface'
import comTreeSelect from '@/views/system/user/selecTree.vue'
import { toTreeList } from '@/utils/structure'
const emits = defineEmits(['add'])
const dialogFormVisible = ref(false)
// 查询条件
const listQuery = ref({
  staffNo: '', // 人员编号
  name: '', // 姓名
  deptId: '', // 所在部门
  limit: 10,
  offset: 1,
})
const loadingTable = ref<boolean>(false)
const list = ref([]) // 表格数据
const total = ref<number>(0)
const select = ref()
const columns = ref([
  {
    text: '人员编号',
    value: 'staffNo',
  },
  {
    text: '姓名',
    value: 'name',
  },
  {
    text: '所在部门',
    value: 'deptId',
  },
])
// 获取部门
const deptProps = reactive({
  parent: 'pid', value: 'id', label: 'name', children: 'children',
})
const deptIdList = ref([])
const getDeptList = () => {
  getDeptTreeList().then((res) => {
    deptIdList.value = toTreeList(res.data, '0', true)
  })
}
// 获取数据列表
const fetchData = () => {
  select.value = -1
  getStaffList(listQuery.value).then((res) => {
    if (res.code === 200) {
      list.value = res.data.records
      total.value = Number(res.data.total)
    }
  })
}
// 搜索
const search = () => {
  fetchData()
}
const selectTreeRef = ref()
// 重置
const reset = () => {
  listQuery.value = {
    staffNo: '',
    name: '', // 姓名
    deptId: '', // 所在部门
    limit: 20,
    offset: 1,
  }
  selectTreeRef.value.clearSelected()
  search()
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number;page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击保存
const submitForm = () => {
  if (select.value >= 0) {
    const person = list.value.filter((item, index) => index == select.value)[0]
    getStaffDetail(person).then((res) => {
      if (res.code === 200) {
        emits('add', res.data)
        dialogFormVisible.value = false
        reset()
      }
    })
  }
  else {
    ElMessage.warning('请先选择人员')
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  reset()
}
// 初始化
const initDialog = () => {
  dialogFormVisible.value = true
  getDeptList()
  fetchData()
}
defineExpose({ initDialog })
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择人员" width="50%">
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-input v-model.trim="listQuery.staffNo" placeholder="人员编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.name" placeholder="姓名" clearable />
      </search-item>
      <search-item>
        <!-- <el-select v-model="listQuery.deptId" placeholder="所在部门" clearable style="width: 150px;">
          <el-option v-for="item in deptIdList" :key="item.id" :label="item.name" :value="item.id" />
        </el-select> -->
        <com-tree-select
          ref="selectTreeRef" v-model="listQuery.deptId" :options="deptIdList"
          placeholder="所在部门" :tree-props="deptProps"
        />
      </search-item>
    </search-area>
    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery"
        :list-loading="loadingTable" @change="changePage"
      >
        <template #preColumns>
          <el-table-column label="选择" width="55" align="center">
            <template #default="scope">
              <el-radio v-model="select" :label="scope.$index" class="radio" />
            </template>
          </el-table-column>
        <!-- <el-table-column label="#" width="55" align="center">
          <template #default="scope">
            {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
          </template>
        </el-table-column> -->
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="submitForm">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
